// generated by Fast Light User Interface Designer (fluid) version 1.0300

#ifndef CsoundGUIMain_FLTK_hpp
#define CsoundGUIMain_FLTK_hpp
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Menu_Button.H>

class CsoundGUIMain {
public:
  CsoundGlobalSettings currentGlobalSettings; 
  CsoundPerformanceSettings currentPerformanceSettings; 
  CsoundUtilitySettings currentUtilitySettings; 
private:
  CsoundGUIConsole consoleWindow; 
  CSOUND *csound; 
  CsoundPerformance *csPerf; 
  int prvTime; 
  bool performing; 
  bool paused; 
  CsoundGlobalSettingsPanel *globalSettingsWindow; 
  CsoundPerformanceSettingsPanel *performanceSettingsWindow; 
  CsoundUtilitiesWindow *utilitiesWindow; 
  CsoundEditorWindow *orcEditorWindow; 
  CsoundEditorWindow *scoEditorWindow; 
  CsoundAboutWindow *aboutWindow; 
  CsoundUtility *utility_listOpcodes; 
  CsoundUtility *utility_cvanal; 
  CsoundUtility *utility_pvanal; 
  CsoundUtility *utility_hetro; 
  CsoundUtility *utility_lpanal; 
  CsoundUtility *utility_sndinfo; 
  CsoundUtility *utility_srconv; 
  CsoundUtility *utility_dnoise; 
public:
  int utilityState; 
  CsoundGUIMain();
  Fl_Double_Window *window;
  Fl_Input *orcNameInput;
private:
  void cb_orcNameInput_i(Fl_Input*, void*);
  static void cb_orcNameInput(Fl_Input*, void*);
public:
  Fl_Button *orcNameButton;
private:
  void cb_orcNameButton_i(Fl_Button*, void*);
  static void cb_orcNameButton(Fl_Button*, void*);
public:
  Fl_Button *editOrcButton;
private:
  void cb_editOrcButton_i(Fl_Button*, void*);
  static void cb_editOrcButton(Fl_Button*, void*);
public:
  Fl_Input *scoreNameInput;
private:
  void cb_scoreNameInput_i(Fl_Input*, void*);
  static void cb_scoreNameInput(Fl_Input*, void*);
public:
  Fl_Button *scoreNameButton;
private:
  void cb_scoreNameButton_i(Fl_Button*, void*);
  static void cb_scoreNameButton(Fl_Button*, void*);
public:
  Fl_Button *editScoreButton;
private:
  void cb_editScoreButton_i(Fl_Button*, void*);
  static void cb_editScoreButton(Fl_Button*, void*);
public:
  Fl_Input *outfileNameInput;
private:
  void cb_outfileNameInput_i(Fl_Input*, void*);
  static void cb_outfileNameInput(Fl_Input*, void*);
public:
  Fl_Button *outfileNameButton;
private:
  void cb_outfileNameButton_i(Fl_Button*, void*);
  static void cb_outfileNameButton(Fl_Button*, void*);
public:
  Fl_Button *editOutfileButton;
private:
  void cb_editOutfileButton_i(Fl_Button*, void*);
  static void cb_editOutfileButton(Fl_Button*, void*);
public:
  Fl_Button *playOutfileButton;
private:
  void cb_playOutfileButton_i(Fl_Button*, void*);
  static void cb_playOutfileButton(Fl_Button*, void*);
public:
  Fl_Check_Button *realtimeIOToggle;
private:
  void cb_realtimeIOToggle_i(Fl_Check_Button*, void*);
  static void cb_realtimeIOToggle(Fl_Check_Button*, void*);
public:
  Fl_Button *configureRealtimeIO;
private:
  void cb_configureRealtimeIO_i(Fl_Button*, void*);
  static void cb_configureRealtimeIO(Fl_Button*, void*);
public:
  Fl_Output *scoreTimeDisplay;
  Fl_Button *rewindButton;
  Fl_Button *playButton;
private:
  void cb_playButton_i(Fl_Button*, void*);
  static void cb_playButton(Fl_Button*, void*);
public:
  Fl_Button *fastForwardButton;
private:
  void cb_fastForwardButton_i(Fl_Button*, void*);
  static void cb_fastForwardButton(Fl_Button*, void*);
public:
  Fl_Button *stopButton;
private:
  void cb_stopButton_i(Fl_Button*, void*);
  static void cb_stopButton(Fl_Button*, void*);
public:
  Fl_Button *applyScoreOffsetButton;
private:
  void cb_applyScoreOffsetButton_i(Fl_Button*, void*);
  static void cb_applyScoreOffsetButton(Fl_Button*, void*);
public:
  Fl_Value_Input *scoreOffsetInput;
private:
  void cb_scoreOffsetInput_i(Fl_Value_Input*, void*);
  static void cb_scoreOffsetInput(Fl_Value_Input*, void*);
  void cb_Options_i(Fl_Menu_Button*, void*);
  static void cb_Options(Fl_Menu_Button*, void*);
  void cb_Utilities_i(Fl_Button*, void*);
  static void cb_Utilities(Fl_Button*, void*);
  void cb_Messages_i(Fl_Button*, void*);
  static void cb_Messages(Fl_Button*, void*);
  void cb_Help_i(Fl_Menu_Button*, void*);
  static void cb_Help(Fl_Menu_Button*, void*);
public:
  ~CsoundGUIMain(); 
  void setTimeDisplay(double timeVal); 
  static int runCmd(std::string&); 
  static bool isEmptyString(std::string&); 
  static void stripString(std::string&, const char *); 
  static bool isCSDFile(std::string&); 
  static bool isRtAudioDevice(std::string&, bool); 
  static bool browseFile(std::string&, const char *, int, bool); 
  void updateGUIState_orcName(); 
  void updateGUIState_scoName(); 
  void updateGUIState_outFile(); 
  void updateGUIState_controls(); 
  void updateGUIState_MIDI(); 
  void updateGUIState(); 
  void updateGUIValues(); 
  void run(int argc, char **argv); 
  void startPerformance(); 
  void editOrcFile(); 
  void editScoreFile(); 
  void editSoundFile(const char *); 
  void playSoundFile(const char*); 
  std::string oldOutFilename; 
  void setRealtimeCheckbox(int checked); 
  void runHelpBrowser(string page); 
private:
  static int yieldCallback(CSOUND *); 
  void checkUtilities(); 
public:
  void openGlobalSettingsWindow(); 
private:
  void closeGlobalSettingsWindow(); 
public:
  void openPerformanceSettingsWindow(int tab = 0); 
  void closePerformanceSettingsWindow(); 
  void openUtilitiesWindow(); 
private:
  void closeUtilitiesWindow(); 
public:
  void openAboutWindow(); 
private:
  void closeAboutWindow(); 
public:
  void openOrcEditor(string file); 
  void closeOrcEditor(); 
  void openScoEditor(string file); 
  void closeScoEditor(); 
  void startListOpcodes(); 
  void stopListOpcodes(); 
  void startCvanal(); 
  void stopCvanal(); 
  void startPvanal(); 
  void stopPvanal(); 
  void startHetro(); 
  void stopHetro(); 
  void startLpanal(); 
  void stopLpanal(); 
  void startSndinfo(); 
  void stopSndinfo(); 
  void startSrconv(); 
  void stopSrconv(); 
  void startDnoise(); 
  void stopDnoise(); 
  void pushPlayPauseButton(); 
  void pushStopButton(); 
  void pushRewindButton(); 
  void pushOpenOrcButton(); 
  void pushOpenScoButton(); 
};
#endif
